<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Datastructure: src/heap.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Datastructure
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">heap.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="heap_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * To change this license header, choose License Headers in Project Properties.</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * To change this template file, choose Tools | Templates</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * and open the template in the editor.</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">/* </span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * File:   heap.h</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * Author: aurelio</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;stdbool.h&gt;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#ifndef HEAP_H</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#define HEAP_H</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="heap_8h.html#a7085c62c43230e23f6fa23eed518061e">   19</a></span>&#160;<span class="preprocessor">#define HEAP_MAX_SIZE 100</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="struct_heap.html">   21</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span>{</div>
<div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="struct_heap.html#ac5cbb8d8b1c5becee82f849bbd36d100">   22</a></span>&#160;    <span class="keywordtype">float</span> data[<a class="code" href="heap_8h.html#a7085c62c43230e23f6fa23eed518061e">HEAP_MAX_SIZE</a>];</div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="struct_heap.html#a750b5d744c39a06bfb13e6eb010e35d0">   23</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="struct_heap.html#a750b5d744c39a06bfb13e6eb010e35d0">index</a>;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;} <a class="code" href="struct_heap.html">Heap</a>;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* HEAP_H */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="heap_8h.html#ab43d0eafaa5ff8ac2dba0657750fdf4c">   29</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="heap_8h.html#ab43d0eafaa5ff8ac2dba0657750fdf4c">init_heap</a>(<a class="code" href="struct_heap.html">Heap</a> *h);</div>
<div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="heap_8h.html#a85f425d55995d4bfe7d42a8317fcbedc">   30</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="heap_8h.html#a85f425d55995d4bfe7d42a8317fcbedc">is_heap_empty</a>(<a class="code" href="struct_heap.html">Heap</a> *h);</div>
<div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="heap_8h.html#a962611a81a4cd5a8b824c1a271f75a3e">   31</a></span>&#160;<span class="keywordtype">float</span> <a class="code" href="heap_8h.html#a962611a81a4cd5a8b824c1a271f75a3e">pop</a>(<a class="code" href="struct_heap.html">Heap</a> *h); <span class="comment">//pop the root value</span></div>
<div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="heap_8h.html#a7394afbcf1f644c42ed4f381344e0c89">   32</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="heap_8h.html#a7394afbcf1f644c42ed4f381344e0c89">push</a>(<a class="code" href="struct_heap.html">Heap</a> *h, <span class="keywordtype">float</span> value);</div>
<div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="heap_8h.html#a54c0ba5c00a105a220a161ec717208a7">   33</a></span>&#160;<span class="keywordtype">float</span> <a class="code" href="heap_8h.html#a54c0ba5c00a105a220a161ec717208a7">replace</a>(<a class="code" href="struct_heap.html">Heap</a> *h, <span class="keywordtype">float</span> value); <span class="comment">// pop root and push a new key.</span></div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="heap_8h.html#af684013e1c65b2beb9c21efef6baf505">   34</a></span>&#160;<span class="keywordtype">float</span> <a class="code" href="heap_8h.html#af684013e1c65b2beb9c21efef6baf505">peek</a>(<a class="code" href="struct_heap.html">Heap</a> *h); <span class="comment">// return root value but dont remove it</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment">//En option</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment">//void heapify(Heap *s, float array[], size_t array_size); //create Heap from array</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment">//void merge(Heap *dest, Heap *src); //merge src into dest</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="ttc" id="aheap_8h_html_a54c0ba5c00a105a220a161ec717208a7"><div class="ttname"><a href="heap_8h.html#a54c0ba5c00a105a220a161ec717208a7">replace</a></div><div class="ttdeci">float replace(Heap *h, float value)</div></div>
<div class="ttc" id="aheap_8h_html_a7085c62c43230e23f6fa23eed518061e"><div class="ttname"><a href="heap_8h.html#a7085c62c43230e23f6fa23eed518061e">HEAP_MAX_SIZE</a></div><div class="ttdeci">#define HEAP_MAX_SIZE</div><div class="ttdef"><b>Definition:</b> heap.h:19</div></div>
<div class="ttc" id="aheap_8h_html_a7394afbcf1f644c42ed4f381344e0c89"><div class="ttname"><a href="heap_8h.html#a7394afbcf1f644c42ed4f381344e0c89">push</a></div><div class="ttdeci">void push(Heap *h, float value)</div></div>
<div class="ttc" id="aheap_8h_html_a85f425d55995d4bfe7d42a8317fcbedc"><div class="ttname"><a href="heap_8h.html#a85f425d55995d4bfe7d42a8317fcbedc">is_heap_empty</a></div><div class="ttdeci">bool is_heap_empty(Heap *h)</div></div>
<div class="ttc" id="aheap_8h_html_a962611a81a4cd5a8b824c1a271f75a3e"><div class="ttname"><a href="heap_8h.html#a962611a81a4cd5a8b824c1a271f75a3e">pop</a></div><div class="ttdeci">float pop(Heap *h)</div></div>
<div class="ttc" id="aheap_8h_html_ab43d0eafaa5ff8ac2dba0657750fdf4c"><div class="ttname"><a href="heap_8h.html#ab43d0eafaa5ff8ac2dba0657750fdf4c">init_heap</a></div><div class="ttdeci">void init_heap(Heap *h)</div></div>
<div class="ttc" id="aheap_8h_html_af684013e1c65b2beb9c21efef6baf505"><div class="ttname"><a href="heap_8h.html#af684013e1c65b2beb9c21efef6baf505">peek</a></div><div class="ttdeci">float peek(Heap *h)</div></div>
<div class="ttc" id="astruct_heap_html"><div class="ttname"><a href="struct_heap.html">Heap</a></div><div class="ttdef"><b>Definition:</b> heap.h:21</div></div>
<div class="ttc" id="astruct_heap_html_a750b5d744c39a06bfb13e6eb010e35d0"><div class="ttname"><a href="struct_heap.html#a750b5d744c39a06bfb13e6eb010e35d0">Heap::index</a></div><div class="ttdeci">int index</div><div class="ttdef"><b>Definition:</b> heap.h:23</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
